<script lang="ts">
	import { auth, db } from '$lib/firebase/firebase';
	import {
		deleteDoc,
		doc,
		type DocumentData,
		collection,
		getDocs,
		addDoc
	} from 'firebase/firestore';
	import { onMount } from 'svelte';
	import type { Horaire } from '../type';
	import Button from '../../../../../components/Button.svelte';
	import AddTimeForm from './AddTimeForm.svelte';
	import { Trash2Icon } from 'svelte-feather-icons';

	let horaires: Horaire[] = [];

	const getHoraires = async () => {
		horaires = [];
		const docRef = await getDocs(collection(db, 'horaires'));
		docRef.forEach((doc) => {
			horaires.push({ ...doc.data(), id: doc.id } as Horaire);
		});
		horaires = horaires;
	};

	const deleteOneHoraire = async (id: string) => {
		await deleteDoc(doc(db, 'horaires', id));
		await getHoraires();
	};

	const putHoraires = async (e: any) => {
		const docRef = collection(db, 'horaires');
		await addDoc(docRef, e.detail.newHoraires);
		await getHoraires();
		openForm = false;
	};

	onMount(() => {
		getHoraires();
	});

	let openForm: boolean = false;
</script>

<div class="flex flex-col gap-4 items-center justify-center text-center w-1/2">
	<h1>Horaires</h1>
	<div class="flex flex-col gap-2">
		<div class="w-full">
			<Button on:click={() => (openForm = !openForm)}>
				{openForm ? 'Fermer' : 'Ajouter une horaire'}
			</Button>
		</div>
		{#if openForm}
			<AddTimeForm on:add={putHoraires} />
		{/if}
	</div>
	<div class="w-fit">
		{#each horaires as horaire, index}
			<div class="flex gap-2 items-center justify-between p-2">
				<div class="flex gap-2 items-center">
					<span>{horaire.jour}</span>
					<span>{horaire.horaireFrom} - {horaire.horaireTo}</span>
				</div>
				<Button type="error" on:dblclick={() => horaire.id && deleteOneHoraire(horaire.id)}>
					<Trash2Icon />
				</Button>
			</div>
			{#if index < horaires.length - 1}
				<div class="border-b border-primary-500 w-full" />
			{/if}
		{/each}
	</div>
</div>
